<template>
  <div class="login-container mt-40">
    <!-- Headline with Logo -->
    <div class="h6">
      <div class="d-flex justify-content-center">
        <img
          v-if="currentTheme === 'dark'"
          alt="Coscine Logo"
          src="@/assets/svg/coscine_white.svg"
          class="d-inline"
        />
        <img
          v-else
          alt="Coscine Logo"
          src="@/assets/svg/coscine_rgb.svg"
          class="d-inline"
        />
      </div>
      <div class="d-flex justify-content-center mt-3">
        {{ $t("page.headline") }}
      </div>
    </div>
    <RouterView v-if="moduleIsReady" />
    <div
      class="flex-grow d-flex"
      :class="{ 'text-bg-secondary': darkModeActive }"
    >
      <!-- Partner -->
      <section class="login-partners flex-fill">
        <div class="row mx-auto">
          <div class="column p-2">
            <div
              v-for="partner in partners"
              :key="partner.key"
              class="login-plakat"
            >
              <a :href="partner.url" target="_blank" rel="noopener noreferrer">
                <img
                  :id="partner.key"
                  class="mx-auto"
                  :alt="partner.name"
                  :src="partner.logo[language]"
                />
                <div class="centered">
                  {{ partner.type }}
                  <br />
                  <b>{{ partner.name }}</b>
                </div>
              </a>
            </div>
          </div>
        </div>
      </section>
    </div>
  </div>
</template>

<script lang="ts">
import useLoginStore from "./store";
import useMainStore from "@/store/index";

// Import images
import coscineNrw_logo from "@/assets/svg/coscineNrw.svg";
import nhr4ces_logo from "@/assets/png/nhr4ces.png";
import iam4nfdi_logo from "@/assets/png/iam4nfdi.png";
import eoscFairImpact_logo from "@/assets/png/eoscFairImpact.png";
import aims_logo from "@/assets/svg/aims.svg";
import nfdi4ing_logo from "@/assets/svg/nfdi4ing.svg";
import nfdiMatwerk_logo from "@/assets/svg/nfdiMatwerk.svg";
import fdmNrw_logo from "@/assets/png/fdmNrw.png";
import nhr_logo from "@/assets/png/nhr.png";
import itc_logo from "@/assets/svg/itc.svg";
import dfg_en_logo from "@/assets/png/dfg_en.png";
import dfg_de_logo from "@/assets/png/dfg_de.png";
import mkwNrw_logo from "@/assets/svg/mkwNrw.svg";
import dhNrw_logo from "@/assets/png/dhNrw.png";

import type { Partner } from "../login/types";
import type { Theme } from "@/store/types";
import { SupportedLanguages } from "../project/i18n";

export default defineComponent({
  setup() {
    const loginStore = useLoginStore();
    const mainStore = useMainStore();

    return { loginStore, mainStore };
  },

  data() {
    return {
      images: {
        coscineNrw: { en: coscineNrw_logo, de: coscineNrw_logo },
        nhr4ces: { en: nhr4ces_logo, de: nhr4ces_logo },
        iam4nfdi: { en: iam4nfdi_logo, de: iam4nfdi_logo },
        eoscFairImpact: { en: eoscFairImpact_logo, de: eoscFairImpact_logo },
        aims: { en: aims_logo, de: aims_logo },
        nfdi4ing: { en: nfdi4ing_logo, de: nfdi4ing_logo },
        nfdiMatwerk: { en: nfdiMatwerk_logo, de: nfdiMatwerk_logo },
        fdmNrw: { en: fdmNrw_logo, de: fdmNrw_logo },
        nhr: { en: nhr_logo, de: nhr_logo },
        itc: { en: itc_logo, de: itc_logo },
        dfg: { en: dfg_en_logo, de: dfg_de_logo },
        mkwNrw: { en: mkwNrw_logo, de: mkwNrw_logo },
        dhNrw: { en: dhNrw_logo, de: dhNrw_logo },
      } satisfies Record<string, Record<SupportedLanguages, string>>,
    };
  },

  computed: {
    isLoggedIn(): boolean {
      return this.loginStore.isLoggedIn;
    },
    currentTheme(): Theme {
      return this.mainStore.currentTheme;
    },
    darkModeActive(): boolean {
      return this.currentTheme === "dark";
    },
    moduleIsReady(): boolean {
      return true;
    },
    language(): SupportedLanguages {
      return this.$i18n.locale as SupportedLanguages;
    },
    partners(): Partner[] {
      const partnersData = this.$tm("page.partners");

      return Object.keys(partnersData).map((key) => {
        // Ensure TypeScript knows that `key` is one of the keys of `images`
        const imageKey = key as keyof typeof this.images;
        return {
          key: key,
          type: this.$t(`page.partners.${key}.type`),
          name: this.$t(`page.partners.${key}.title`),
          logo: this.images[imageKey],
          url: this.$t(`page.partners.${key}.url`),
        };
      });
    },
  },

  mounted() {
    this.initialize();
    this.preloadImages();
  },

  methods: {
    async initialize() {
      await this.loginStore.retrieveLoginUrls();
    },
    preloadImages() {
      // Preload all partner images
      Object.values(this.images).forEach((langs) => {
        Object.values(langs).forEach((src) => {
          const img = new Image();
          img.src = src;
        });
      });
    },
  },
});
</script>

<style scoped>
.login-partners {
  text-align: center;
  padding-top: 0px;
  padding-right: 0px;
  padding-bottom: 53px;
  padding-left: 0px;
  display: flex;

  a::after {
    content: "";
  }

  h3 {
    margin-bottom: 30px;
  }

  .row {
    display: flex;
    flex-wrap: wrap;
    justify-content: center;
  }

  /* Create four equal columns that sits next to each other */
  .column {
    flex: 50%;
    max-width: 75%;
    padding: 0 4px;
  }

  .column img {
    margin-top: 8px;
    vertical-align: middle;
    max-width: 250px;
    max-height: 125px;
    padding: 25px;
  }

  .login-plakat {
    display: inline-block;
    position: relative;
    min-width: 250px;
  }

  .login-plakat:hover img {
    opacity: 0.1;
    transition: 0.5s ease;
  }

  .login-plakat:hover .centered {
    opacity: 1;
    transition: 0.5s ease;
  }

  .centered {
    opacity: 0;
    position: absolute;
    top: 50%;
    left: 50%;
    width: 100%;
    padding: 25px;
    transform: translate(-50%, -50%);
  }
}

.login-container {
  min-height: calc(100vh - (53px + 160px));
  display: flex;
  flex-direction: column;
  margin-right: -36px;
  margin-left: -36px;
}
</style>
